﻿using Sfs2X.Protocol.Serialization;
using System;

namespace sfs2x.extension.test.serialization.model
{
    interface Item
    {
        string GetId();
        void SetId(string id);
        
        int GetPrice();
        void SetPrice(int price);

        bool IsActive();
        void SetActive(bool active);


        void UseItem();
        void Sell();
        void Buy();
    }

    class KnifeItem : Item, SerializableSFSType
    {
        string id;
        int price;
        bool active;

        public KnifeItem() { }
        public KnifeItem(string id = null, int price = 85)
        {
            this.id = id;
            this.price = price;
            this.active = true;
        }

        public string GetId() { return id; }
        public int GetPrice() { return price; }
        public bool IsActive() { return active; }

        public void SetId(string id) { this.id = id; }
        public void SetPrice(int price) { this.price = price; }
        public void SetActive(bool active) { this.active = active; }

        public void UseItem()
        {
            Console.WriteLine("Using: " + id);
        }

        public void Sell()
        {
            Console.WriteLine(id + " Sold");
        }

        public void Buy()
        {
            Console.WriteLine(id + " Bought");
        }
    }


    class MagicWand : Item, SerializableSFSType
    {
        string id;
        int price;
        bool active;

        public MagicWand() { }
        public MagicWand(string id = null, int price = 220)
        {
            this.id = id;
            this.price = price;
            this.active = true;
        }

        public string GetId() { return id; }
        public int GetPrice() { return price; }
        public bool IsActive() { return active; }

        public void SetId(string id) { this.id = id; }
        public void SetPrice(int price) { this.price = price; }
        public void SetActive(bool active) { this.active = active; }

        public void UseItem()
        {
            Console.WriteLine("Using: " + id);
        }

        public void Sell()
        {
            Console.WriteLine(id + " Sold");
        }

        public void Buy()
        {
            Console.WriteLine(id + " Bought");
        }
    }

    class SledgeHammerItem : Item, SerializableSFSType
    {
        string id;
        int price;
        bool active;

        public SledgeHammerItem() { }
        public SledgeHammerItem(string id = null, int price = 130)
        {
            this.id = id;
            this.price = price;
            this.active = true;
        }

        public string GetId() { return id; }
        public int GetPrice() { return price; }
        public bool IsActive() { return active; }

        public void SetId(string id) { this.id = id; }
        public void SetPrice(int price) { this.price = price; }
        public void SetActive(bool active) { this.active = active; }

        public void UseItem()
        {
            Console.WriteLine("Using: " + id);
        }

        public void Sell()
        {
            Console.WriteLine(id + " Sold");
        }

        public void Buy()
        {
            Console.WriteLine(id + " Bought");
        }
    }


    class ShieldItem : Item, SerializableSFSType
    {
        string id;
        int price;
        bool active;

        public ShieldItem() { }
        public ShieldItem(string id = null, int price = 90)
        {
            this.id = id;
            this.price = price;
            this.active = true;
        }

        public string GetId() { return id; }
        public int GetPrice() { return price; }
        public bool IsActive() { return active; }

        public void SetId(string id) { this.id = id; }
        public void SetPrice(int price) { this.price = price; }
        public void SetActive(bool active) { this.active = active; }

        public void UseItem()
        {
            Console.WriteLine("Using: " + id);
        }

        public void Sell()
        {
            Console.WriteLine(id + " Sold");
        }

        public void Buy()
        {
            Console.WriteLine(id + " Bought");
        }
    }


    class SwordItem : Item, SerializableSFSType
    {
        string id;
        int price;
        bool active;

        public SwordItem() { }
        public SwordItem(string id = null, int price = 90)
        {
            this.id = id;
            this.price = price;
            this.active = true;
        }

        public string GetId() { return id; }
        public int GetPrice() { return price; }
        public bool IsActive() { return active; }

        public void SetId(string id) { this.id = id; }
        public void SetPrice(int price) { this.price = price; }
        public void SetActive(bool active) { this.active = active; }

        public void UseItem()
        {
            Console.WriteLine("Using: " + id);
        }

        public void Sell()
        {
            Console.WriteLine(id + " Sold");
        }

        public void Buy()
        {
            Console.WriteLine(id + " Bought");
        }
    }

}
