﻿using Sfs2X.Protocol.Serialization;
using System.Collections;

namespace sfs2x.extension.test.serialization.model
{
    class RpgCharacter : SerializableSFSType
    {
        private static string NEW_LINE = "\n";
        private static string TAB = "\t";

        private string name;
        private string type;
        private Skin skin;
        private ArrayList inventory;
        private Hashtable properties;
        private Hashtable spells;

        public RpgCharacter() { }
        public RpgCharacter(string name = null, string type = null, Skin skin = null)
        {
            this.name = name;
            this.type = type;
            this.skin = skin;
        }

        public override string ToString() 
        {
            string key;
            string str = "";

            str += "-------------------------------------------" + NEW_LINE;
            str += " RPG Character: " + name + NEW_LINE;
            str += "-------------------------------------------" + NEW_LINE;
            str += TAB + "Type: " + type + NEW_LINE;

            str += TAB + "Inventory: " + NEW_LINE;
            if (inventory != null)
            {
                foreach (object obj in inventory)
                {
                    Item invItem = (Item)obj;
                    str += TAB + TAB + invItem.GetId() + " -- Price: " + invItem.GetPrice() + ", Active: " + invItem.IsActive() + NEW_LINE;
                }
            }

            str += TAB + "Spells: " + NEW_LINE;
            if (spells != null)
            {
                foreach (DictionaryEntry entry in spells)
                {
                    Spell spell = (Spell) entry.Value;
                    str += TAB + TAB + spell.GetId() + " -- HitPoints: " + spell.GetHitPoints() + ", Qty: " + spell.Count() + NEW_LINE;
                }
            }

            str += TAB + "Properties: " + NEW_LINE;

            if (properties != null)
            {
                foreach (DictionaryEntry entry in properties)
                {
                    CharacterProperty prop = (CharacterProperty) entry.Value;
                    str += TAB + TAB + entry.Key + " -- " + prop.ToString() + NEW_LINE;
                }
            }

            return str;
        }
    }
}
