package
{
	import com.smartfoxserver.v2.SmartFox;
	import com.smartfoxserver.v2.core.SFSEvent;
	import com.smartfoxserver.v2.entities.data.ISFSArray;
	import com.smartfoxserver.v2.entities.data.ISFSObject;
	import com.smartfoxserver.v2.entities.data.SFSObject;
	import com.smartfoxserver.v2.requests.ExtensionRequest;
	import com.smartfoxserver.v2.requests.LoginRequest;
	
	import flash.display.Sprite;
	import flash.net.sendToURL;
	
	import sfs2x.extension.test.serialization.model.*;
	
	public class RpgExtensionClient extends Sprite
	{
		//-------------------------------------------------------------------------
		// This is necessary in order to include the classes in the compiled SWF
		//-------------------------------------------------------------------------
		private var characterProperty:CharacterProperty;
		private var deathRaySpell:DeathRaySpell;
		private var item:Item;
		private var knifeItem:KnifeItem;
		private var knightSkin:KnightSkin;
		private var risingFlamesSpell:RisingFlamesSpell;
		private var rpgCharacter:RpgCharacter;
		private var shieldItem:ShieldItem;
		private var solarVortexSpell:SolarVortexSpell;
		private var spiderSwarmSpell:SpiderSwarmSpell;
		private var sorcererSkin:SorcererSkin;
		private var spell:Spell;
		private var swordItem:SwordItem;
		private var waterFloodSpell:WaterFloodSpell;
		//-------------------------------------------------------------------------
		
		private var sfs:SmartFox;
		
		public function RpgExtensionClient()
		{
			sfs = new SmartFox();
			sfs.addEventListener(SFSEvent.CONNECTION, onConnection);
			sfs.addEventListener(SFSEvent.LOGIN, onLogin);
			sfs.addEventListener(SFSEvent.ROOM_JOIN, onRoomJoin);
			sfs.addEventListener(SFSEvent.CONFIG_LOAD_FAILURE, onConfigFailure);
			sfs.addEventListener(SFSEvent.EXTENSION_RESPONSE, onExtension);
			
			// Load external config and connect
			sfs.loadConfig();
		}
		
		private function onConnection(evt:SFSEvent):void
		{
			if (evt.params.success)
			{
				// Login as guest
				sfs.send(new LoginRequest());
			}
		}
		

		private function onLogin(evt:SFSEvent):void
		{
			trace("Logged as: " + sfs.mySelf.name)
			
			sfs.send(new ExtensionRequest("getModel", new SFSObject()));
		}
		
		private function onRoomJoin(evt:SFSEvent):void
		{
			trace("Joined in: " + evt.params.room.name)
		}
		
		private function onConfigFailure(evt:SFSEvent):void
		{
			trace("Config not found!");
		}
		
		private function onExtension(evt:SFSEvent):void
		{
			if (evt.params.cmd == "getModel")
			{
				trace("GOT MODEL:")
				var data:ISFSObject = evt.params.params;
				dumpModel(data)
				
				// Send the same data back to the Server to rebuild it on the other side.
				sfs.send(new ExtensionRequest("setModel", data));
				trace("MODEL SENT!")
			}
		}
		
		private function dumpModel(data:ISFSObject):void
		{
			var characters:ISFSArray = data.getSFSArray("knights")
			
			for (var i:int = 0; i < characters.size(); i++)
			{
				var knight:RpgCharacter = characters.getClass(i) as RpgCharacter;
				trace(knight.toString());
			}
		}
		
	}
}