package sfs2x.extension.test.serialization.model 
{
	import com.smartfoxserver.v2.protocol.serialization.SerializableSFSType;

	public class RpgCharacter implements SerializableSFSType
	{
		private static const NEW_LINE:String = "\n"
		private static const TAB:String = "\t"
		
		private var _name:String
		private var _type:String
		private var _skin:Skin
		private var _inventory:Array
		private var _properties:Object
		private var _spells:Object
	
		public function RpgCharacter(name:String=null, type:String=null, skin:Skin=null)
	    {
		    super()
		    this._name = name
		    this._type = type
		    this._skin = skin
	    }
		
		public function get name():String {
	    	return _name
	    }
		public function set name(name:String):void {
	    	this._name = name
	    }
		public function get type():String {
	    	return _type
	    }
		public function set type(type:String):void {
	    	this._type = type
	    }
		public function get skin():Skin {
	    	return _skin
	    }
		public function set skin(skin:Skin):void {
	    	this._skin = skin
	    }
		public function get inventory():Array
	    {
	    	return _inventory
	    }
		public function set inventory(inventory:Array):void {
	    	this._inventory = inventory
	    }
		public function get properties():Object
	    {
	    	return _properties
	    }
		public function set properties(properties:Object):void {
	    	this._properties = properties
	    }
		public function get spells():Object
	    {
	    	return _spells
	    }
		public function set spells(spells:Object):void {
	    	this._spells = spells
	    }
		
		public function toString():String
		{
			var key:String;
			var str:String = "";
			
			str += "+------------------------------------+" + NEW_LINE
			str += " RPG Character: " + _name + NEW_LINE
			str += "+------------------------------------+" + NEW_LINE
			str += TAB + "Type: " + _type + NEW_LINE
			
			str += TAB + "Inventory: " + NEW_LINE
			if (_inventory != null)
				for each (var inventoryItem:Item in _inventory)
					str += TAB + TAB + inventoryItem.id + " -- Price: " + inventoryItem.price + ", Active: " + inventoryItem.active + NEW_LINE
				
			str += TAB + "Spells: " + NEW_LINE
			if (_spells != null)
				for (key in _spells)
					str += TAB + TAB + key + " -- HitPoints: " + _spells[key].hitPoints + ", Qty: " + _spells[key].count + NEW_LINE
					
			str += TAB + "Properties: " + NEW_LINE
			
			if (_properties != null)
				for (key in _properties)
					str += TAB + TAB + key + " -- " + _properties[key].toString() + NEW_LINE
			
			return str
		}
	}
}