package sfs2x.extension.test.serialization.model;

import java.util.List;
import java.util.Map;

import com.smartfoxserver.v2.protocol.serialization.SerializableSFSType;

public class RpgCharacter implements SerializableSFSType
{
	private static final String TAB = "\t";
	private static final String NEW_LINE = "\n";
	
	private String name;
	private String type;
	private Skin skin;
	private List<Item> inventory;
	private Map<String, CharacterProperty> properties;
	private Map<String, Spell> spells;
	
	public RpgCharacter()
    {
	    // TODO Auto-generated constructor stub
    }
	
	public RpgCharacter(String name, String type, Skin skin)
    {
	    this.name = name;
	    this.type = type;
	    this.skin = skin;
    }
	public String getName()
    {
    	return name;
    }
	public void setName(String name)
    {
    	this.name = name;
    }
	public String getType()
    {
    	return type;
    }
	public void setType(String type)
    {
    	this.type = type;
    }
	public Skin getSkin()
    {
    	return skin;
    }
	public void setSkin(Skin skin)
    {
    	this.skin = skin;
    }
	public List<Item> getInventory()
    {
    	return inventory;
    }
	public void setInventory(List<Item> inventory)
    {
    	this.inventory = inventory;
    }
	public Map<String, CharacterProperty> getProperties()
    {
    	return properties;
    }
	public void setProperties(Map<String, CharacterProperty> properties)
    {
    	this.properties = properties;
    }
	public Map<String, Spell> getSpells()
    {
    	return spells;
    }
	public void setSpells(Map<String, Spell> spells)
    {
    	this.spells = spells;
    }
	
	@Override
	public String toString()
	{
		StringBuilder sb = new StringBuilder();
		
		sb.append("+------------------------------------+").append(NEW_LINE);
		sb.append(" RPG Character: ").append(name).append(NEW_LINE);
		sb.append("+------------------------------------+").append(NEW_LINE);
		sb.append(TAB).append("Type: ").append(type).append(NEW_LINE);

		sb.append(TAB + "Inventory: ").append(NEW_LINE);
		if (inventory != null)
			for (Item inventoryItem : inventory)
				sb.append(TAB).append(TAB).append(inventoryItem.getId()).append(" -- Price: ").append(inventoryItem.getPrice()).append(", Active: ").append(inventoryItem.isActive()).append(NEW_LINE);
			
		sb.append(TAB).append("Spells: ").append(NEW_LINE);
		if (spells != null)
			for (Map.Entry<String, Spell> entry : spells.entrySet())
				sb.append(TAB).append(TAB).append(entry.getKey()).append(" -- HitPoints: ").append(entry.getValue().getHitPoints()).append(", Qty: ").append(entry.getValue().getCount()).append(NEW_LINE);
				
		sb.append(TAB).append("Properties: ").append(NEW_LINE);

		if (properties != null)
			for (Map.Entry<String, CharacterProperty> entry : properties.entrySet())
				sb.append(TAB).append(TAB).append(entry.getKey()).append(" -- ").append(entry.getValue()).append(NEW_LINE);

	    return sb.toString();
	}
}
